/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: sample1.c 2416 2012-09-07 08:06:20Z ertl-hiro $
 */


#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
//#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "sample1.h"
#include <string.h>


void  WaitMsec( int );

void  dev_init( void );
void  dev_led_on( void );
void  dev_led_off( void );
int   dev_get_btn_stat( void );
int   dev_get_lmt1_stat( void );
int   dev_get_lmt2_stat( void );

void  dev_init( void );
void  dev_tim_pwm_init32( void );
void  dev_tim_pwm_set32( int val );

void  dev_mdrv_mot1_cw( void );
void  dev_mdrv_mot1_ccw( void );
void  dev_mdrv_mot1_brake( void );
void  dev_mdrv_mot1_stop( void );
void  dev_mdrv_mot2_cw( void );
void  dev_mdrv_mot2_ccw( void );
void  dev_mdrv_mot2_brake( void );
void  dev_mdrv_mot2_stop( void );

void  lcd_pset( int x, int y, int color );
void  lcd_pset_fontaR( unsigned char *font, int x, int y, int fg, int bg );
void  lcd_put_stringR( int x, int y, int fg, int bg, unsigned char *msg, int size );
void  lcd_pset_fonta( unsigned char *font, int x, int y, int fg, int bg );
void  lcd_put_string( int x, int y, int fg, int bg, unsigned char *msg, int size );
void  lcd_pset_fonta2( unsigned char *font, int x, int y, int fg, int bg );
void  lcd_put_string2( int x, int y, int fg, int bg, unsigned char *msg, int size );
void  lcd_dispbuff( unsigned char *buff );
void  lcd_fill( int x0, int x1, int y0, int y1, int color );
void  lcd_fill_full( int color );
void  lcd_set_rgb565_bmp( void *bitmap );
void  lcd_set_rgb565_bmp240x240( unsigned char  *bmp );
void  lcd_init( void );

void  xspi_init( void );

extern  unsigned char  ic01_bmp[];
extern  unsigned char  ic02_bmp[];
extern  unsigned char  ic03_bmp[];
extern  unsigned char  ic04_bmp[];

unsigned char  *lcd_ic_table[] = {
  ic01_bmp,
  ic02_bmp,
  ic03_bmp,
  ic04_bmp,
  0x0
};

volatile  int  motor_x_next;
volatile  int  motor_y_next;
volatile  int  motor_x_flag;
volatile  int  motor_y_flag;
volatile  int  master_flag;


/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))


/*
 *  ¹ԤƼ¹Ԥ륿ѤΥ㳰롼
 */
void tex_routine(TEXPTN texptn, intptr_t exinf)
{
}

/*
 *  CPU㳰ϥɥ
 */
#ifdef CPUEXC1

void
cpuexc_handler(void *p_excinf)
{
}

#endif /* CPUEXC1 */


void  delay( int delay )
{
	tslp_tsk( delay );
}

#define  DEF_HEAD_UP     1500
#define  DEF_HEAD_DOWN    800


void  mot_head_ctrl( int up )
{
  if( up != 0 ) {
    dev_tim_pwm_set32( DEF_HEAD_DOWN );
  } else {
    dev_tim_pwm_set32( DEF_HEAD_UP );
  }

  tslp_tsk( 500 );
}


void  mot_motor_x_cw( int val )
{
  int  delta = 5;

  if( val <= 0 || val > 1500 ) {
    return;
  }

  dev_mdrv_mot1_cw();

  while( 1 ) {
    if( val < delta ) {
      delta = val;
    }
    tslp_tsk( delta );

    val -= delta;
    if( val <= 0 ) {
      break;
    }
  }

  dev_mdrv_mot1_brake();
  tslp_tsk( 200 );

  dev_mdrv_mot1_stop();
  tslp_tsk( 100 );
}


void  mot_motor_x_ccw( int val )
{
  int  delta = 5;

  if( dev_get_lmt1_stat() != 0 ) {
    return;
  }

  if( val <= 0 ) {
    return;
  }

  dev_mdrv_mot1_ccw();

  while( 1 ) {
    if( val < delta ) {
      delta = val;
    }
    tslp_tsk( delta );

    val -= delta;
    if( val <= 0 ) {
      break;
    }

    if( dev_get_lmt1_stat() != 0 ) {
      break;
    }
  }

  dev_mdrv_mot1_brake();
  tslp_tsk( 200 );

  dev_mdrv_mot1_stop();
  tslp_tsk( 100 );
}


void  mot_motor_y_cw( int val )
{
  int  delta = 5;

  if( val < 0 || val > 1500 ) {
    return;
  }

  dev_mdrv_mot2_cw();

  while( 1 ) {
    if( val < delta ) {
      delta = val;
    }
    tslp_tsk( delta );

    val -= delta;
    if( val <= 0 ) {
      break;
    }
  }

  dev_mdrv_mot2_brake();
  tslp_tsk( 200 );
  dev_mdrv_mot2_stop();
  tslp_tsk( 100 );
}


void  mot_motor_y_ccw( int val )
{
  int  delta = 5;

  if( dev_get_lmt2_stat() != 0 ) {
    return;
  }

  dev_mdrv_mot2_ccw();

  while( 1 ) {
    if( val < delta ) {
      delta = val;
    }
    tslp_tsk( delta );

    val -= delta;
    if( val <= 0 ) {
      break;
    }

    if( dev_get_lmt2_stat() != 0 ) {
      break;
    }
  }

  dev_mdrv_mot2_brake();
  tslp_tsk( 200 );
  dev_mdrv_mot2_stop();
  tslp_tsk( 100 );
}


void main_task(intptr_t exinf)
{
  syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

  motor_x_next = 0;
  motor_y_next = 0;
  motor_x_flag = 0;
  motor_y_flag = 0;
  master_flag = 0;

  xspi_init();
  lcd_init();

  {
    char  *msg;
    msg = "Automated";
    lcd_put_string2( 20,  60, 0xf800, 0x0000, (unsigned char *)msg, strlen(msg) );
    msg = "Programming";
    lcd_put_string2( 20, 120, 0x07e0, 0x0000, (unsigned char *)msg, strlen(msg) );
    msg = "System";
    lcd_put_string2( 20, 180, 0xffe0, 0x0000, (unsigned char *)msg, strlen(msg) );
    msg = "DEMO";
    lcd_put_string2( 80, 260, 0xffff, 0x0000, (unsigned char *)msg, strlen(msg) );
  }

  dev_init();
  dev_tim_pwm_init32();

  SVC_PERROR(act_tsk(TASK1));
  SVC_PERROR(act_tsk(TASK2));
  SVC_PERROR(act_tsk(TASK3));

  master_flag = 1;

  while( 1 ) {
    tslp_tsk( 1000 );
  }
}


void task1(intptr_t exinf)
{
  int  tbl = 0;

  syslog(LOG_NOTICE, "task1()");

  while( master_flag == 0 ) {
    tslp_tsk( 10 );
  }

  /* head up */
  dev_led_on();
  mot_head_ctrl( 1 );
  dly_tsk( 1000 );
  dev_led_off();

  /* goto home position */
  motor_x_next = 2000;
  motor_x_flag = 0x0002; /* ccw */
  motor_y_next = 2000;
  motor_y_flag = 0x0002; /* ccw */

  while( motor_x_flag != 0 || motor_y_flag != 0 ) {
    tslp_tsk( 10 );
  }
  tslp_tsk( 1000 );

  while( 1 ) {
    //syslog(LOG_NOTICE, "CHIP catch up.");

    /* CHIP catch up */
    motor_x_next = 1000;
    motor_x_flag = 0x0001; /* cw */
    motor_y_next = 1000;
    motor_y_flag = 0x0002; /* ccw */
    while( motor_x_flag != 0 || motor_y_flag != 0 ) {
      tslp_tsk( 10 );
    }

    /* head down */
    mot_head_ctrl( 0 );
    tslp_tsk( 1000 );
    /* head up */
    mot_head_ctrl( 1 );
    tslp_tsk( 500 );

    /* goto bottom check pos */
    motor_x_next = 350;
    motor_x_flag = 0x0002; /* ccw */
    motor_y_next = 620;
    motor_y_flag = 0x0001; /* cw */
    while( motor_x_flag != 0 || motor_y_flag != 0 ) {
      tslp_tsk( 10 );
    }

    dev_led_on();
    tslp_tsk( 500 );
    if( lcd_ic_table[ tbl ] == 0x0 ) {
      tbl = 0;
    }
    lcd_set_rgb565_bmp240x240( lcd_ic_table[ tbl ] );
    lcd_fill( 0, 239, 240, 319, 0xffff );
    tbl++;
    tslp_tsk( 500 );
    dev_led_off();
    tslp_tsk( 500 );

    /* goto write pos */
    motor_x_next = 820;
    motor_x_flag = 0x0002; /* ccw */
    motor_y_next = 280;
    motor_y_flag = 0x0002; /* ccw */
    while( motor_x_flag != 0 || motor_y_flag != 0 ) {
      tslp_tsk( 10 );
    }

    tslp_tsk( 500 );

    /* head down */
    mot_head_ctrl( 0 );

    syslog(LOG_NOTICE, "DATA Writiing.");
    {
      char  *msg;
      int  loop;
      msg = "Writing";
      for( loop=0 ; loop<5 ; loop++ ) {
        lcd_put_string2( 4, 250, 0xf800, 0xffff, (unsigned char *)msg, strlen(msg) );
        tslp_tsk( 250 );
        lcd_put_string2( 4, 250, 0x0000, 0xffff, (unsigned char *)msg, strlen(msg) );
        tslp_tsk( 250 );
      }
    }

    syslog(LOG_NOTICE, "Write Success!");
    {
      char *msg;
      msg = "OK!";
      lcd_put_string2( 175, 250, 0x001f, 0xffff, (unsigned char *)msg, strlen(msg) );
    }
    tslp_tsk( 500 );

    syslog(LOG_NOTICE, "DATA Verifying.");
    {
      char  *msg;
      int  loop;
      msg = "Verifying";
      for( loop=0 ; loop<5 ; loop++ ) {
        lcd_put_string2( 4, 285, 0xf800, 0xffff, (unsigned char *)msg, strlen(msg) );
        tslp_tsk( 250 );
        lcd_put_string2( 4, 285, 0x0000, 0xffff, (unsigned char *)msg, strlen(msg) );
        tslp_tsk( 250 );
      }
    }

    syslog(LOG_NOTICE, "Write Success!");
    {
      char *msg;
      msg = "OK!";
      lcd_put_string2( 175, 285, 0x001f, 0xffff, (unsigned char *)msg, strlen(msg) );
    }
    tslp_tsk( 500 );

    /* head up */
    mot_head_ctrl( 1 );
    tslp_tsk( 500 );
  }
}


void task2(intptr_t exinf)
{
  syslog(LOG_NOTICE, "task2()");

  while( 1 ) {
    while( motor_x_flag == 0 ) {
      tslp_tsk( 10 );
    }

    syslog(LOG_NOTICE, "task2() get command. %d", motor_x_flag);

    if( motor_x_flag & 0x0002 ) {
      mot_motor_x_ccw( motor_x_next );
    } else if( motor_x_flag & 0x0001 ) {
      mot_motor_x_cw( motor_x_next );
    }

    motor_x_next = 0;
    motor_x_flag = 0;
  }
}


void task3(intptr_t exinf)
{
  syslog(LOG_NOTICE, "task3()");

  while( 1 ) {
    while( motor_y_flag == 0 ) {
      tslp_tsk( 10 );
    }

    syslog(LOG_NOTICE, "task3() get command. %d", motor_y_flag);


    if( motor_y_flag & 0x0002 ) {
      mot_motor_y_ccw( motor_y_next );
    } else if( motor_y_flag & 0x0001 ) {
      mot_motor_y_cw( motor_y_next );
    }

    motor_y_flag = 0;
    motor_y_next = 0;
  }
}

